#############################################################
#
# ethtool
#
#############################################################

ETHTOOL_SOURCE_URL=http://cogent.dl.sourceforge.net/sourceforge/gkernel
ETHTOOL_SOURCE=ethtool-3.tar.gz
ETHTOOL_DIR=$(BUILD_DIR)/ethtool-3

ETHTOOL_PKG_DIR=$(PACKAGES_DIR)/ethtool

$(DL_DIR)/$(ETHTOOL_SOURCE):
	 $(WGET) -P $(DL_DIR) $(ETHTOOL_SOURCE_URL)/$(ETHTOOL_SOURCE)

ethtool-source: $(DL_DIR)/$(ETHTOOL_SOURCE)

$(ETHTOOL_DIR)/.unpacked: $(DL_DIR)/$(ETHTOOL_SOURCE)
	zcat $(DL_DIR)/$(ETHTOOL_SOURCE) | tar -C $(BUILD_DIR) -xvf -
	touch $(ETHTOOL_DIR)/.unpacked

$(ETHTOOL_DIR)/.configured: $(ETHTOOL_DIR)/.unpacked
	(cd $(ETHTOOL_DIR); rm -rf config.cache; \
		./configure --prefix=$(ETHTOOL_PKG_DIR)/usr \
		CFLAGS="$(TARGET_CFLAGS)" \
	);
	touch $(ETHTOOL_DIR)/.configured

$(ETHTOOL_DIR)/ethtool: $(ETHTOOL_DIR)/.configured
	$(MAKE) CFLAGS="$(TARGET_CFLAGS)" -C $(ETHTOOL_DIR)

$(ETHTOOL_PKG_DIR)/usr/sbin/ethtool: $(ETHTOOL_DIR)/ethtool
	-rm -rf  $(ETHTOOL_PKG_DIR)
	mkdir -p $(ETHTOOL_PKG_DIR)/usr/sbin
	cp -a $(ETHTOOL_DIR)/ethtool $(ETHTOOL_PKG_DIR)/usr/sbin/.
	$(SSTRIP) $(ETHTOOL_PKG_DIR)/usr/sbin/ethtool

$(PACKAGES_DIR)/ethtool.ffw: $(ETHTOOL_PKG_DIR)/usr/sbin/ethtool
	(cd $(PACKAGES_DIR); sh mkpack ethtool)

ethtool: $(PACKAGES_DIR)/ethtool.ffw

ethtool-clean:
	-$(MAKE) -C $(ETHTOOL_DIR) clean
	-rm -rf $(ETHTOOL_PKG_DIR)/*

ethtool-dirclean:
	-rm -rf $(ETHTOOL_DIR)
	-rm -rf  $(ETHTOOL_PKG_DIR)
