#############################################################
#
# iptables
#
#############################################################
IPTABLES_SOURCE_URL=http://www.netfilter.org/files
IPTABLES_SOURCE=iptables-1.3.3.tar.bz2
IPTABLES_BUILD_DIR=$(BUILD_DIR)/iptables-1.3.3

$(DL_DIR)/$(IPTABLES_SOURCE):
	 $(WGET) -P $(DL_DIR) $(IPTABLES_SOURCE_URL)/$(IPTABLES_SOURCE) 

$(IPTABLES_BUILD_DIR)/.unpacked: $(DL_DIR)/$(IPTABLES_SOURCE)
	bzcat $(DL_DIR)/$(IPTABLES_SOURCE) | tar -C $(BUILD_DIR) -xvf -
	touch $(IPTABLES_BUILD_DIR)/.unpacked

$(IPTABLES_BUILD_DIR)/.configured: $(IPTABLES_BUILD_DIR)/.unpacked
	touch  $(IPTABLES_BUILD_DIR)/.configured

$(IPTABLES_BUILD_DIR)/iptables: $(IPTABLES_BUILD_DIR)/.configured
	$(MAKE) -C $(IPTABLES_BUILD_DIR) \
		KERNEL_DIR=$(BUILD_DIR)/linux \
		DO_IPV6=0  \
		DESTDIR=$(ADD_MASTER)/ \
		PREFIX=/	\
		BINDIR=/sbin	\
		LIBDIR=/lib	\
		INCDIR=$(TMP_DIR)/include	\
		MANDIR=$(TMP_DIR)/man 	\
		CC="$(TARGET_CC)"	\
		COPT_FLAGS="$(TARGET_CFLAGS) -DNDEBUG" \

$(ADD_MASTER)/sbin/iptables: $(IPTABLES_BUILD_DIR)/iptables
	-rm $(ADD_MASTER)/lib/iptables/*
	$(MAKE) -C $(IPTABLES_BUILD_DIR) \
		KERNEL_DIR=$(BUILD_DIR)/linux \
		DO_IPV6=0  \
		DESTDIR=$(ADD_MASTER)/ \
		PREFIX=/	\
		BINDIR=/sbin	\
		LIBDIR=/lib	\
		INCDIR=$(TMP_DIR)/include	\
		MANDIR=$(TMP_DIR)/man 	\
		CC="$(TARGET_CC)"	\
		COPT_FLAGS="$(TARGET_CFLAGS) -DNDEBUG" \
		install
	rm $(ADD_MASTER)/sbin/iptables-restore
	rm $(ADD_MASTER)/sbin/iptables-save
	# I hate doing this: (and I really want gcc 3.4)
	rm $(ADD_MASTER)/lib/iptables/libipt_sctp.so
	rm $(ADD_MASTER)/lib/iptables/libipt_dscp.so
	rm $(ADD_MASTER)/lib/iptables/libipt_DSCP.so
	rm $(ADD_MASTER)/lib/iptables/libipt_TARPIT.so
	rm $(ADD_MASTER)/lib/iptables/libipt_MIRROR.so
	rm -rf $(ADD_MASTER)$(TMP_DIR)/*
	rm -rf $(ADD_MASTER)/usr$(TMP_DIR)/*
	-$(SSTRIP) $(ADD_MASTER)/sbin/iptables
	-$(SSTRIP) $(ADD_MASTER)/lib/iptables/*

iptables: $(ADD_MASTER)/sbin/iptables 

iptables-source: $(DL_DIR)/$(IPTABLES_SOURCE)

iptables-clean:
	-$(MAKE) -C $(IPTABLES_BUILD_DIR) \
		KERNEL_DIR=$(BUILD_DIR)/linux \
		DO_IPV6=0  \
		DESTDIR=$(ADD_MASTER)/ \
		PREFIX=/	\
		BINDIR=/sbin	\
		LIBDIR=/lib	\
		INCDIR=$(TMP_DIR)/include	\
		MANDIR=$(TMP_DIR)/man 	\
		clean

iptables-dirclean:
	rm -rf $(IPTABLES_BUILD_DIR)

